#[macro_use]
extern crate rocket;

use db::DB;
use dotenv::dotenv;

mod db;
mod routes;

#[rocket::main]
async fn main() {
    dotenv().ok();

    let db = DB::init().await;

    let launch_result = rocket::build()
        .manage(db)
        .mount("/", routes![
            routes::site_index
        ])
        .launch();

    launch_result.await.expect("Could not start Rocket");
}
